//
//  ProductListPresenter.swift
//  SuperSpaManagement
//
//  Created by PHAM ANH TUAN on 3/21/21.
//  Copyright (c) 2021 ___ORGANIZATIONNAME___. All rights reserved.
//
//  This file was generated by the 🐍 VIPER generator
//

import Foundation
import RxSwift
import RxCocoa


enum ProductListNavigationOption {
    case productInfoEditting(style: ProductInfoEditingStyle)
}

protocol ProductListWireframeInterface: WireframeInterface {
    func navigate(to option: ProductListNavigationOption)
}

final class ProductListPresenter: ProductListPresenterInterface {
    var addProductTrigger = PublishRelay<Void>()
    
    
    // MARK: - Private properties -
    private let disposeBag = DisposeBag()
    
    private unowned let view: ProductListViewInterface
    private let interactor: ProductListInteractorInterface
    private let wireframe: ProductListWireframeInterface
    
    // MARK: - Lifecycle -
    
    init(view: ProductListViewInterface, interactor: ProductListInteractorInterface, wireframe: ProductListWireframeInterface) {
        self.view = view
        self.interactor = interactor
        self.wireframe = wireframe
        
        configureViewActions()
    }
}

extension ProductListPresenter {
    func configureViewActions() {
        addProductTrigger
            .subscribeNext { [weak wireframe] in
                wireframe?.navigate(to: .productInfoEditting(style: .create))
            }
            .disposed(by: disposeBag)
    }
}

// MARK: - Extensions -

extension ProductListPresenter {
}
